/*
 *  utility.h
 *  PHIGS
 *
 *  Created by Simone Portuesi on 15/03/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include <math.h>

/* Various utility functions and macro */

/* Utility MACRO */
#define sqr(x) ((x)*(x))
#define deg2rad(deg) (M_PI*(deg)/180)


/* Macros for inline Vectro op, use with care */
/* apply (_ op c) to all elements of vector, result in vr */
#define VECT_OP_SCAL(vr,op,v1,c) { int i; for(i=0;i<3;i++) vr[i]=v1[i] op c; }

/* apply (a op b) to every pair of coordinates, result in vr */
#define VECT_OP_VECT(vr,op,v1,v2) { int i; for(i=0;i<3;i++) vr[i]=v1[i] op v2[i]; }

/* Vector norm, immediate result */
#define NORM_VECT(v) sqrt(v[0]*v[0]+v[1]*v[1]+v[2]*v[2])

/* Vectro cross product vr= v1 x v2 */
#define CROSSPROD(vr,v1,v2) { vr[0]=v1[1]*v2[2]-v1[2]*v2[1]; \
                              vr[1]=v1[2]*v2[0]-v1[0]*v2[2]; \
							  vr[2]=v1[0]*v2[1]-v1[1]*v2[0]; }
							  
							  